"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const internals_1 = require("../internals");
const core_1 = require("@collectable/core");
const internals_2 = require("../internals");
function set(key, value, tree) {
    var immutable = core_1.isImmutable(tree._owner);
    var oldTree = tree;
    if (immutable) {
        tree = internals_2.cloneAsMutable(tree);
    }
    if (tree._size === 0) {
        tree._root = internals_2.createNode(tree._group, false, key, value);
        tree._size = 1;
        return immutable ? internals_2.doneMutating(tree) : tree;
    }
    tree._root = internals_2.editable(tree._group, tree._root);
    var p = internals_2.findPath(key, tree._root, tree._compare, tree._group);
    if (p.next === 0 /* NONE */) {
        var replaced = internals_2.assignValue(value, p.node);
        internals_1.PathNode.release(p, tree._root);
        if (!replaced) {
            tree = oldTree;
        }
    }
    else {
        var node = internals_2.createNode(tree._group, true, key, value);
        internals_2.setChild(p.next, p.node, node);
        internals_2.rebalance(p, node, p.node, tree);
        tree._size++;
    }
    return immutable ? internals_2.doneMutating(tree) : tree;
}
exports.set = set;

//# sourceMappingURL=set.js.map
