import { PathNode } from '../internals';
import { isImmutable } from '@collectable/core';
import { findPath, createNode, editable, rebalance, setChild, cloneAsMutable, doneMutating, assignValue, } from '../internals';
export function set(key, value, tree) {
    var immutable = isImmutable(tree._owner);
    var oldTree = tree;
    if (immutable) {
        tree = cloneAsMutable(tree);
    }
    if (tree._size === 0) {
        tree._root = createNode(tree._group, false, key, value);
        tree._size = 1;
        return immutable ? doneMutating(tree) : tree;
    }
    tree._root = editable(tree._group, tree._root);
    var p = findPath(key, tree._root, tree._compare, tree._group);
    if (p.next === 0 /* NONE */) {
        var replaced = assignValue(value, p.node);
        PathNode.release(p, tree._root);
        if (!replaced) {
            tree = oldTree;
        }
    }
    else {
        var node = createNode(tree._group, true, key, value);
        setChild(p.next, p.node, node);
        rebalance(p, node, p.node, tree);
        tree._size++;
    }
    return immutable ? doneMutating(tree) : tree;
}

//# sourceMappingURL=set.js.map
