import { isImmutable, isDefined, isEqual } from '@collectable/core';
import { set, remove, isEqual as isTreeEqual } from './index';
import { cloneAsMutable, doneMutating, findNodeByKey } from '../internals';
export function updateTree(callback, tree) {
    var newTree;
    var immutable = isImmutable(tree._owner) ? (newTree = cloneAsMutable(tree), true) : (newTree = tree, false);
    newTree = callback(newTree) || newTree;
    return immutable && !isTreeEqual(tree, newTree) ? doneMutating(newTree) : tree;
}
export function update(callback, key, tree) {
    var node = findNodeByKey(key, tree);
    var oldValue = isDefined(node) ? node.value : void 0;
    var newValue = callback(oldValue);
    if (isEqual(oldValue, newValue))
        return tree;
    if (isDefined(newValue)) {
        tree = set(key, newValue, tree);
    }
    else {
        tree = remove(key, tree);
    }
    return tree;
}

//# sourceMappingURL=update.js.map
